;;; -*- lexical-binding: t -*-

(defconst elb-bytechar-buffer
  (let ((buf (get-buffer-create " *elb-bytechar*")))
    (with-current-buffer buf
      (let ((step (apply #'concat "🙂 foo\n" (make-list 2000 "asdf "))))
        (dotimes (_ (/ 10000000 (length step)))
          (insert step))
        buf))))

(defconst elb-bytechar-re "\\<.\\> \\<.\\> bar")

(defun elb-bytechar--aux (nmarkers lookup &optional marker-fun)
  (with-current-buffer elb-bytechar-buffer
    (let ((step (/ (buffer-size) nmarkers))
          (markers nil))
      (dotimes (i nmarkers)
        (push (copy-marker (funcall (or marker-fun #'identity) (* i step)))
              markers))
      (dotimes (_ 10)
        (goto-char (point-min))
        (let ((parse-sexp-lookup-properties lookup))
          (re-search-forward elb-bytechar-re nil t))))))

(defun elb-bytechar-100k-nolookup-entry ()
  (elb-bytechar--aux 100000 nil))

(defun elb-bytechar-nolookup-entry () (elb-bytechar--aux 1 nil))

(defun elb-bytechar-entry () (elb-bytechar--aux 1 t))

(defun elb-bytechar-100k-entry () (elb-bytechar--aux 100000 t))

(defun elb-bytechar-100k-rev-entry ()
  (elb-bytechar--aux 100000 t (lambda (pos) (- (point-max) pos))))

(defun elb-bytechar-100k-random-entry ()
  (elb-bytechar--aux 100000 t (lambda (_) (random (buffer-size)))))

(defun elb-bytechar-10k-random-entry ()
  (elb-bytechar--aux 10000 t (lambda (_) (random (buffer-size)))))

(defun elb-bytechar-1k-random-entry ()
  (elb-bytechar--aux 1000 t (lambda (_) (random (buffer-size)))))
